function draw(irf,txt,vars,periods,sigma,phi)
% draw the impulse response functions of Y,C,K,N,I,A, using the reduced form
%               s_t+1=W*s_t+R*A_t
% input: irf:IRFs
%        vars: draw specified variables
%        periods: the length of the IRFs.
%        otherparameters used to make text marks.
% Wu,Huabin. November 2, 2008. Revised Apr. 2011.
figure; 
plot(1:periods,irf(vars(1),:),'b','LineWidth',1.5);hold on;
plot(1:periods,irf(vars(3),:),'-.g','LineWidth',1.5);
plot(1:periods,irf(vars(2),:),'--r','LineWidth',1.5);
text(.382*periods,.618*irf(vars(1),1),['\sigma =',num2str(sigma),', \eta=',num2str(phi)],'FontSize',14);
legend(txt(vars([1 3 2])));
xlabel('Periods','fontsize',14);
set(gca,'fontsize',14);
