function [FF F2 FS PP P2 PS]=esolve(A1, B1, B2, B2p, idc, idx)
% Solve a DSGE model by second order method.
% Call: transformer.m
% Huabin Wu. Aug. 2009. Revised Apr. 2011.

nv=length(A1);% # variables

[a b q z]=qz(A1,B1);
[a b q z]=ordqz(a,b,q,z,'udo');

idF=find(abs(diag(a))<=abs(diag(b))); % Forward iteration
idB=setdiff(1:nv,idF);                % Backward iteration  
ids=setdiff(1:nv,idc);                % # state variables
if numel(idB)~=numel(ids); 
    FF=[]; F2=[]; FS=[]; PP=[]; P2=[]; PS=[];
    return
end

nc=length(idc);ns=nv-nc;nx=length(idx);

a11=a(idB,idB);a12=a(idB,idF);a22=a(idF,idF);
b11=b(idB,idB);b12=b(idB,idF);b22=b(idF,idF);
zp=z';zp11=zp(idB,ids);zp12=zp(idB,idc);zp21=zp(idF,ids);zp22=zp(idF,idc);
R2=a11/(zp11');D2=b11/(zp11');

PP=-zp22\zp21;  % Coefs for Controls: C_t = PP*S_t
FF=R2\D2;       % Coefs for States:   S_t = FF*S_{t-1}

[LH LC]=transformer(nv);
[lh lc]=transformer(ns);

PHI = lc*kron(FF,FF)*lh;
Omega=[eye(ns);PP];R=LC*kron(Omega,Omega)*lh; 
Gam=zeros(ns,nx);Gam(idx,:)=eye(nx);
GAM = lc*kron(Gam,Gam)*transformer(nx);
% P=permutater(ones(nx,ns+nx));PSI=lc*(kron(FF,Gam)*P+kron(Gam,FF));
Vbar=(eye(size(PHI))-PHI)\GAM;

G=B2*R+B2p*R*PHI;G_hat=q*G;
H=B2p*R*GAM;H_hat=q*H;
T = b22\a22;r2=b22\G_hat(idF,:);M2=zeros(size(r2));
M2(:)=(eye(ns*(ns+1)*nc/2)-kron(PHI',T))\r2(:);
M3=(b22-a22)\(G_hat(idF,:)*Vbar+H_hat(idF,:));
Qa=a11*zp12+a12*zp22;Qb=b11*zp12+b12*zp22;

% Coefs for 2nd order terms.
P2=-zp22\M2;
F2=R2\(Qb*P2+G_hat(idB,:)-Qa*P2*PHI);
PS=-zp22\(M3-M2*Vbar);
FS=R2\(Qb*PS+H_hat(idB,:)-Qa*(PS+P2*GAM));
