function [H C]=transformer(N)
% Generate matrices for transforming between vec and vech.
% vech(#)=C*vec(#), vec(#)=H*vech(#)
% C is N*(N+1)/2 by N^2; H is N^2 by N*(N+1)/2; C*H=eye(N*(N+1)/2).
% Wu,Huabin. June 25,2008. Revised Apr. 2011.

row=N^2;col=N*(N+1)/2;
H=zeros(row,col);
C=H';

index=reshape(1:row,N,N);
U=triu(index);Up=U';
id0=find(U==0);id1=find(U~=0);

H(id1,:)=eye(col);H(id0,:)=H(Up(id0),:);

C(:,id1)=eye(col);
